<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class PurchaseReturnMaster extends BaseModel
{
    use HasFactory;

    protected $guarded = [];

    protected static function boot()
    {
        parent::boot(); // always call the parent boot
        static::addGlobalScope('typeScope', function ($builder) {
            if (auth()->check() && auth()->user()->shop_id != null) {
                $builder->where('transition_location_id', auth()->user()->shop_id);
            }
        });
        static::creating(function ($model) {
            if (auth()->check()) {
                $user = auth()->user();
                $model->transition_location_id = $user->shop_id;
                $model->transition_create_by = $user->id;
            }
        });

        static::updating(function ($model) {
            if (auth()->check()) {
                $model->transition_update_by = auth()->id(); // use user ID here
            }
        });
    }

    public function supplier()
    {
        return $this->hasOne(Supplier::class, 'id', 'supplier_id');
    }

    public function invoice()
    {
        return $this->hasOne(PurchaseMaster::class, 'id', 'purchase_invoice_no');
    }

    public function details()
    {
        return $this->hasMany(PurchaseReturnDetails::class, 'purchase_return_master_id', 'id')->with('attribute', 'product');
    }

    public function returnProduct()
    {
        return $this->hasMany(PurchaseReturnDetails::class, 'purchase_invoice_no', 'purchase_invoice_no');
    }

    public function purchaseDetails()
    {
        return $this->hasMany(PurchaseDetails::class, 'purchase_master_id', 'purchase_invoice_no')->with('attribute', 'product', 'returnProduct');
    }

    public function purchaseDetail()
    {
        return $this->hasOne(PurchaseDetails::class, 'purchase_master_id', 'purchase_invoice_no');
    }
}
